#include "Game.h"
#include "rendering/Renderer.h"
#include "rendering/wrapper/GLFWWrapper.h"
#include "utils/String.h"

Game::Game(const Controller& c, const Clock& fps, const Clock& tps) : controller(c), fps(fps), tps(tps) {
}

void Game::tick() {
}

void Game::render(float lag, Renderer& renderer) const {
    (void) lag;
    renderer.translateTo(0.0f, 0.0f).scale(4.0f).update();
    for(uint i = 0; i < controller.getButtonAmount(); i++) {
        String s(controller.getName(i));
        s.append(": ").append(controller.wasReleased(i)).append(" ").append(controller.getDownTime(i));
        renderer.drawString(0, 10 * i, s);
    }
}

bool Game::isRunning() const {
    return true;
}