#ifndef TEXTURE_H
#define TEXTURE_H

#include <GL/glew.h>

#include "utils/Types.h"

class Texture final {
public:
    Texture();
    ~Texture();
    Texture(const Texture& other) = delete;
    Texture(Texture&& other) = delete;
    Texture& operator=(const Texture& other) = delete;
    Texture& operator=(Texture&& other) = delete;
    
    void setRGBAData(int width, int height, const u32* data);
    void setRGBFloatData(int width, int height, const float* data);
    
    void bind() const;

private:
    GLuint texture;
};

#endif